#<profile4xi profile = "20" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "arrayfunction4xi.py">
#<abstract4xi abstract = "provides function ArrayFunction4Xi" />
#<refer4xi reference = "sharedctypes.py" />
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
#<note4xi note = "function name starts with a capital letter to depict a function given to multiprocessing" />
# -------------------------------------------------------------------------------------------------
#
# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'ArrayFunction4Xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass    
try:                 # rare ones
    import ctypes         
except:
    pass 
         
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing 
except:
    pass
try:                             # Python ones
    from multiprocessing.sharedctypes import Array
except:
    print("arrayfunction4xi.py: *** failed in from multiprocessing.sharedctypes import Array  ***")
#"
#/>
 
# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from examine4xi import examine4xi
from print4xi import print4xi
from rawarray4xi import RawArray4Xi
from rlock4xi import RLock4Xi 
from synchronized_function4xi import synchronized_function4xi
from time4xi import time4xi
#"
#/>


                      
# -------------------------------------------------------------------------------------------------
# Types                              
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/> 
# -------------------------------------------------------------------------------------------------
#
#<type4xi type = "
typecode_to_type = {
    'c': ctypes.c_char,  'u': ctypes.c_wchar, 
    'b': ctypes.c_byte,  'B': ctypes.c_ubyte,
    'h': ctypes.c_short, 'H': ctypes.c_ushort,
    'i': ctypes.c_int,   'I': ctypes.c_uint,
    'l': ctypes.c_long,  'L': ctypes.c_ulong,
    'f': ctypes.c_float, 'd': ctypes.c_double}
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "ArrayFunction4Xi" usage = "
#       s_xi2 = ArrayFunction4Xi('c', 'yourDragonXi', lock=lock_xi2)
#
# Notes:
#       is a function although it starts with capital
#       is NOT registered in syncmanager4xi.py 
#       originally Array
#">
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/> 
# -------------------------------------------------------------------------------------------------
def ArrayFunction4Xi(typecode_or_type, size_or_initializer, *args, lock=True):
    '''
    Array4XiFunction returns a synchronization wrapper for a RawArray4Xi
    '''
    # -----------------------------------------------------------------------------------------
    # (Step 1/6)             
    # -----------------------------------------------------------------------------------------
    class2print = 'ArrayFunction4Xi'
    method2print = 'ArrayFunction4Xi'
    
    message2print = "{(Step 1/6a) started" + "; ArrayFunction4Xi-started: " + str(ArrayFunction4Xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    # <function ArrayFunction4Xi at 0x0000000002B61598>
    
    message2print = "{(Step 1/6b) passed" + "; typecode-or-type-passed-to-ArrayFunction4Xi: " + str(typecode_or_type) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # <class '__main__.Point4Xi'>
    
    message2print = "{(Step 1/6c) passed" + "; size-or-initializer-passed-to-ArrayFunction4Xi: " + str(size_or_initializer) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # [(1.875, -6.25), (-5.75, 2.0), (2.375, 9.5)]
  
    args2pass = args
    message2print = "{(Step 1/6d) passed" + "; args2pass-passed-to-ArrayFunction4Xi: " + str(args2pass) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # ()
    
    message2print = "{(Step 1/6e) passed" + "; lock-passed-to-ArrayFunction4Xi: " + str(lock) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # True
    
    if examine4xi(class2print, method2print):  
        # -------------------------------------------------------------------------------------    
        # StepOriginal
        # -------------------------------------------------------------------------------------             
        message2print = "{(StepOriginal) performing" + "; Array-performing-by-ArrayFunction4Xi: " + str(Array) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
        # <function Array at 0x0000000002B6FC80> 
        
        array2return = None   
        try: 
            lock2pass = lock                
            array2return = Array(typecode_or_type, size_or_initializer, *args, lock=lock2pass)
        except:
            message2print = "{(StepOriginal) failed" + "; Array-failed-by-ArrayFunction4Xi: " + str(Array) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)           
            #  
        finally:
            message2print = "{(StepOriginal) returning" + ";array2return-returning-by-ArrayFunction4Xi: " + str(array2return) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)           
            #         
            return array2return   
    else:       
        # -----------------------------------------------------------------------------------------    
        # (Step 2/6) 
        # -----------------------------------------------------------------------------------------        
        obj2xi = None
        try:
            message2print = "{(Step 2/6a) passing" + "; typecode-or-type-passing-to-RawArray4Xi-by-ArrayFunction4Xi: " + str(typecode_or_type) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # <class '__main__.Point4Xi'>
            
            message2print = "{(Step 2/6b) passing" + "; size-or-initializer-passing-to-RawArray4Xi-by-ArrayFunction4Xi: " + str(size_or_initializer) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # [(1.875, -6.25, 21.1), (-5.75, 2.0, 42.2), (2.375, 9.5, 84.4)]
            
            message2print = "{(Step 2/6c) calling" + "; RawArray4Xi-calling-by-ArrayFunction4Xi: " + str(RawArray4Xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            # <function RawArray4Xi at 0x0000000003162E18>      
                    
            obj2xi = RawArray4Xi(typecode_or_type, size_or_initializer)   
    
            message2print = "{(Step 2/6d) got" + "; obj2xi-got-by-ArrayFunction4Xi: " + str(obj2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # <rawarray4xi.Point4Xi_Array_3 object at 0x0000000003925848>
            
        except:
            message2print = "{(Step 2/6z) failed" + "; obj2xi-failed-by-ArrayFunction4Xi: " + str(obj2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        # -----------------------------------------------------------------------------------------    
        # (Step 3/6) 
        # -----------------------------------------------------------------------------------------        
        if lock is False:
            message2print = "{(Step 3/6) returning" + "; obj2xi-returning-by-ArrayFunction4Xi: " + str(obj2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            return obj2xi
        
        # -----------------------------------------------------------------------------------------    
        # (Step 4/6) 
        # -----------------------------------------------------------------------------------------        
        if lock in (True, None):
            message2print = "{(Step 4/6a) calling" + "; RLock4Xi-calling-by-ArrayFunction4Xi: " + str(RLock4Xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # <class 'rlock4xi.RLock4Xi'>
            
            lock = RLock4Xi()
        
            message2print = "{(Step 4/6b) got" + "; lock-got-by-ArrayFunction4Xi: " + str(lock)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # <RLock4Xi(None, 0)>
            
        # -----------------------------------------------------------------------------------------    
        # (Step 5/6)
        # -----------------------------------------------------------------------------------------        
        if not hasattr(lock, 'acquire'):
            message2print = "{(Step 4/6z) failed" + "; lock-failed-by-ArrayFunction4Xi: " + str(lock)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            
            raise AttributeError("'%r' has no method 'acquire'" % lock)
        
    
        # -----------------------------------------------------------------------------------------    
        # (Step 6/6)
        # -----------------------------------------------------------------------------------------        
    
        message2print = "{(Step 6/6a) passing" + "; obj2xi-passing-to-synchronized_function4xi-by-ArrayFunction4Xi: " + str(obj2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # <rawarray4xi.Point4Xi_Array_3 object at 0x0000000003925848>
        
        message2print = "{(Step 6/6b) passing" + "; lock-passing-to-synchronized_function4xi-by-ArrayFunction4Xi: " + str(lock) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # <RLock4Xi(None, 0)>
            
        message2print = "{(Step 6/6c) returning" + "; synchronized-function4xi-function-returning-by-ArrayFunction4Xi: " + str(synchronized_function4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)        
        # <function synchronized_function4xi at 0x0000000003122BF8>  
        
        return synchronized_function4xi(obj2xi, lock)
    
#</function4xi>

#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

    
    


#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of arrayfunction4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
